<template>
    
    <div id="historias-carrusel" class="carousel slide pb-4" data-bs-ride="carousel" data-interval="false" v-if="usuario">
        <div class="carousel-inner">
            <div class="carousel-item active">
                <div class="row" v-for="historia in listadoHistorias" :key="historia.id" >
                    <div class="col-md-3">
                        <div class="card border-0">
                            <div class="card-img-wrapper">
                                <router-link :to="`/ver-historia/${historia.id}`">
                                    <!--<img id="icono" :src="item.iconURL">-->
                                    <MostrarImagenesHistoria_otrosVue :nombreImagen="historia.imagen"/>
                                    <div class="card-footer border-0 text-white">
                                    {{ historia.id }}
                                    </div>
                                </router-link>
                            </div>
                        </div>
                    </div>            
        </div>
        
        <button class="carousel-control-prev" type="button" data-bs-target="#historias-carrusel" data-bs-slide="prev">
            <span class="carousel-control-prev-icon" aria-hidden="true"></span>
            <span class="visually-hidden">Anterior</span>
        </button>
        <button class="carousel-control-next" type="button" data-bs-target="#historias-carrusel" data-bs-slide="next"
            >
            <span class="carousel-control-next-icon" aria-hidden="true"></span>
            <span class="visually-hidden">Siguiente</span>
        </button>
    </div>
    </div>
    </div>


    <!--modal -->
    <div id="modal-historias">
        <div class="container-fluid h-100" id="contenido-modal-historias">
            <div id="boton-cerrar-modal-historias" @click="ocultarModalHistorias">X</div>
            <div class="row h-100"> 
                <div class="col-12 h-100">
                    <div class="row h-100 p-3" >
                        <div class="col-12 h-100" id="contenedor-foto-perfil-portada-modal" v-if="historiaSeleccionada">
                            <img :src="historiaSeleccionada.imagen">
                            <div class="container-fluid" id="modal-foto-perfil-portada-texto">
                                <div class="row">
                                    <div class="col-12">
                                        <p></p>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>


</template>

<script>
import axios from 'axios';
import MostrarImagenesHistoria_otrosVue from '../public_histo/MostrarImagenesHistoria_otros.vue';

export default {
    name: "CarruselHistorias",
    components:{
        MostrarImagenesHistoria_otrosVue
    },
    data() {
        return {
            usuario:{},
            listadoHistorias: []
        }
    },
    props:{
        muro:{}
    },
    methods: {

        slideNext() {
            const carouselElement = document.getElementById('historias-carrusel');
            const cardWidth = carouselElement.querySelector('.card').offsetWidth;
            const slideOffset = cardWidth / 3;
            carouselElement.scrollBy(slideOffset, 0);
        },
        

        mostrarModalHistorias(){
            let modal = document.getElementById("modal-historias");
            let contenido=document.getElementById("contenido-modal-historias");
            modal.style.display = "block";

            setTimeout(() => {
                modal.style.background = "rgba(0, 0, 0, 0.65)";
                contenido.style.opacity="100%";
                modal.style.setProperty("backdrop-filter", "blur(10px)");
            }, 0);
        },

        ocultarModalHistorias(){
            let modal=document.getElementById("modal-historias");
            let contenido=document.getElementById("contenido-modal-historias");
            modal.style.setProperty("backdrop-filter", "blur(0px)");
            modal.style.background = "rgba(0, 0, 0, 0)";
            contenido.style.opacity="0";

            setTimeout(()=>{
                modal.style.display="none";
            },100)
        },
        

        async cargarUsuario(){
            try{
                const data = await axios.get("http://localhost:3001/usuarios/sesion");
                const usuario=data.data;
                this.usuario=usuario;
            }catch(e){
                console.log(e);
            }
        },

        async buscarHistoria(){
            console.log("id usuario"+this.usuario.id)
            if (this.usuario?.id) {
                    await axios
                    .get(`http://localhost:3001/h/historias_id?id_historia=${this.usuario.id}`)
                    .then((response) => {
                    this.historiaSeleccionada = response.data;
                    console.log("respuesta historias: " + response.data);
                    })
                .catch((error) => {
                    console.error(error);
                });
            }
        },

        async buscarTodasLasHistorias(){
            try {
                console.log(this.usuario);
                let res=await axios.get(`http://localhost:3001/h/historias_muro_id?id_muro=${this.muro.id}`);
                this.listadoHistorias=res.data;
            } catch (error) {
                console.log(error);
            }
        },



    },
    async mounted(){
        await this.cargarUsuario();
        await this.buscarTodasLasHistorias();
    }
}
</script>

<style scoped>
.card {
  position: relative;
  background-color: transparent;
  height: 200px;
}

.card-img-wrapper {
  border-radius: 5%;
}

.card-img-wrapper img{
  height: 200px;
  background-repeat: no-repeat;
  object-fit: cover;
  width: 100%;
  max-width: 100%;
  overflow: hidden;
  
}

.card-footer {
  position: absolute;
  bottom: 0;
  left: 0;
  right: 0;
  background-color: transparent;
  color: white;
  padding: 10px;
}


#icono {
  border-radius:50%;
  border:3px solid #3877e1;
  background-repeat: no-repeat;
  background-size: cover;
  width:45px;
  height:45px;
  margin:5px;
  position:absolute;
  
}

</style>